﻿/**
* Hotrocket ReactionaryScroller Class
*   by Cam Fraser July 21, 2006
*   www.hotrocket.ca/flightpath
*
*   You may distribute this class freely, provided it is not modified in any way (including
*   removing this header or changing the package path).
*
*   Please contact info@hotrocket.ca prior to distributing modified versions of this class.
*/

class com.hotrocket.ReactionaryScroller extends MovieClip {

	public var menuContainer:MovieClip;	// Destination movie clip for scrollable content
	public var menuMask:MovieClip;		// Mask movie clip
	public var startDepth:Number = 1;	// Depth of menuContainer (menuMask is startDepth+1)
	public var maxSpeed:Number=10;		// Speed of scroll at edges of mask

	// Margins for the mask
	public var left:Number = 0;
	public var right:Number = 0;
	public var top:Number = 0;
	public var bottom:Number = 0;

	// Class Variables
	private var scrollingDir:Number=0;

	public function ReactionaryScroller() {

		// Create menuContainer MC
		this.menuContainer = this.createEmptyMovieClip("menuContainer", startDepth);
		this.menuContainer._x = this.left;
		this.menuContainer._y = this.top;

		// Create menuMask MC
		this.menuMask = this.createEmptyMovieClip("menuMask", startDepth+1);
		this.menuMask._x = this.left;
		this.menuMask._y = this.top;
		
		// Draw Mask
		this.menuMask.lineStyle(0, 0, 100);
		this.menuMask.beginFill(0xFFFFFF, 100);
		this.menuMask.lineTo(this._width-this.right-this.left, 0);
		this.menuMask.lineTo(this._width-this.right-this.left, this._height-this.bottom-this.top);
		this.menuMask.lineTo(0, this._height-this.bottom-this.top);
		this.menuMask.lineTo(0, 0);
		this.menuMask.endFill();
		
		// Activate Mask
		this.menuContainer.setMask(this.menuMask);
		
	}
	
	private function onEnterFrame():Void {
		if(scrollingDir!=0) {
			menuContainer._y=Math.min(menuMask._y, Math.max(menuMask._y-(menuContainer._height-menuMask._height),menuContainer._y+scrollingDir));
		}
	}
	
	private function onMouseMove():Void {
		// Is mouse in menu?
		if(_xmouse<=menuMask._x+menuMask._width && _xmouse>=menuMask._x && _ymouse<=menuMask._y+menuMask._height && _ymouse>=menuMask._y) {
			scrollingDir=Math.round(maxSpeed*((-1*((_ymouse-menuMask._y)-menuMask._height/2))/(menuMask._height/2)));
		} else {
			scrollingDir=0;
		}
	}
	
}

